from lib2to3.tests.test_fixers import FixerTestCase as lib2to3FixerTestCase
import sqlite3

from my2to3.trace import conn, get_data, tracing_functions


class FixerTestCase(lib2to3FixerTestCase):
  # Subclass to replace "fixer_pkg"
  def setUp(self, fix_list=None, fixer_pkg="my2to3", options=None):
    super(FixerTestCase, self).setUp(fix_list, fixer_pkg, options)

    # Clear the database
    with conn:
      for table in conn.execute("SELECT name FROM sqlite_master WHERE type='table'").fetchall():
        conn.execute("DELETE FROM %s" % table)

  def assertDataEqual(self, table, data):
    self.assertEqual(get_data(table), data)

  def exec_code(self, string):
    exec(compile(string, "<string>", 'exec'), {f.__name__: f for f in tracing_functions})
